<template>
  <div class="programs-page">
    <IntroSection :title="page_name" />
    <template
      v-if="
        built_environment_programs.length > 0 ||
        built_environment_non_programs.length > 0
      "
    >
      <SectionTitle title="Programs in Built Environment" />
      <div class="program-group">
        <ProgramList
          v-if="built_environment_programs.length > 0"
          title="Degree Program"
          :data="built_environment_programs"
          style="border-top: 0"
          class="degree-program-list"
        />
        <ProgramList
          v-if="built_environment_non_programs.length > 0"
          title="Non-degree Program"
          style="border-top: 0"
          :data="built_environment_non_programs"
        />
      </div>
    </template>
    <template
      v-if="
        design_strategy_programs.length > 0 ||
        design_strategy_non_programs.length > 0
      "
    >
      <SectionTitle title="Programs in Design & Strategy" />
      <div class="program-group">
        <ProgramList
          v-if="design_strategy_programs.length > 0"
          title="Degree Program"
          :data="design_strategy_programs"
          style="border-top: 0"
          class="degree-program-list"
        />
        <ProgramList
          v-if="design_strategy_non_programs.length > 0"
          title="Non-degree Program"
          style="border-top: 0"
          :data="design_strategy_non_programs"
        />
      </div>
    </template>
  </div>
</template>

<script>
import _ from "lodash";
import qs from "qs";
import { mapMutations } from "vuex";

export default {
  data() {
    return {
      page_name: "Programs",
      built_environment_programs: [],
      design_strategy_programs: [],
      built_environment_non_programs: [],
      design_strategy_non_programs: [],
    };
  },
  head({ $config }) {
    return {
      title: `${this.page_name} - ${$config.title}`,
    };
  },
  async mounted() {
    this.setAppLoading(true);
    await Promise.all([
      this.getBuiltEnvironmentPrograms(),
      this.getDesignStrategyPrograms(),
      this.getBuiltEnvironmentNonPrograms(),
      this.getDesignStrategyNonPrograms(),
    ]);
    this.setAppLoading(false);
  },
  methods: {
    ...mapMutations(["setAppLoading"]),
    async getBuiltEnvironmentPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "program in built environment",
            },
          },
          sort: ["id:asc"],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/programs?${query}`);
        let data = _.get(res, "data");

        this.built_environment_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.title"),
            description: _.get(d, "attributes.description"),
            image:
              process.env.api_url +
              _.get(
                d,
                "attributes.overview_slider_images.data[0].attributes.url"
              ),
            url: `/programs/${d.id}`,
          };
        });
      } catch (error) {
        console.log("getBuiltEnvironmentPrograms ~ error:", error);
      }
    },
    async getDesignStrategyPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "program in design & strategy",
            },
          },
          sort: ["id:asc"],
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/programs?${query}`);
        let data = _.get(res, "data");

        this.design_strategy_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.title"),
            description: _.get(d, "attributes.description"),
            image:
              process.env.api_url +
              _.get(
                d,
                "attributes.overview_slider_images.data[0].attributes.url"
              ),
            url: `/programs/${d.id}`,
          };
        });
      } catch (error) {
        console.log("getDesignStrategyPrograms ~ error:", error);
      }
    },
    async getBuiltEnvironmentNonPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "programs in built environment",
            },
          },
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/non-deegree-programs?${query}`);
        let data = _.get(res, "data");

        this.built_environment_non_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.name"),
            description: _.get(d, "attributes.description"),
            url: _.get(d, "attributes.url"),
            image:
              process.env.api_url +
              _.get(d, "attributes.image.data.attributes.url"),
            link_type: "external",
          };
        });
      } catch (error) {
        console.log("getBuiltEnvironmentNonPrograms ~ error:", error);
      }
    },
    async getDesignStrategyNonPrograms() {
      const query = qs.stringify(
        {
          populate: "*",
          filters: {
            program_in: {
              $eq: "programs in design & strategy",
            },
          },
        },
        {
          encodeValuesOnly: true,
        }
      );

      try {
        const res = await this.$appApi.get(`/non-deegree-programs?${query}`);
        let data = _.get(res, "data");

        this.design_strategy_non_programs = _.map(data, (d) => {
          return {
            ...d,
            title: _.get(d, "attributes.name"),
            description: _.get(d, "attributes.description"),
            url: _.get(d, "attributes.url"),
            image:
              process.env.api_url +
              _.get(d, "attributes.image.data.attributes.url"),
            link_type: "external",
          };
        });
      } catch (error) {
        console.log("getDesignStrategyNonPrograms ~ error:", error);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.programs-page {
  .program-group {
    padding-top: 40px;
    border-top: 1px solid $color-primary-500;
  }
}
</style>
